void initMatrix () {
  for (int i=0;i<12;i++) {
    pinMode(matrix_pins[i],OUTPUT);
  }
  setupMatrix();
}

void setupMatrix () {
  // asociar el pin de las columnas
  cols[0] = matrix_pins[0];
  cols[1] = matrix_pins[2];
  cols[2] = matrix_pins[9];
  cols[3] = matrix_pins[6];
  cols[4] = matrix_pins[7];
  // asociar el pin de las filas
  rows[0] = matrix_pins[11];
  rows[1] = matrix_pins[10];
  rows[2] = matrix_pins[1];
  rows[3] = matrix_pins[8];
  rows[4] = matrix_pins[3];
  rows[5] = matrix_pins[4];
  rows[6] = matrix_pins[5];
}

void clearMatrix () {
  int i;
  for (i=0;i<12;i++) {
    digitalWrite(matrix_pins[i],LOW);
  }
}

void drawMatrix () {
  unsigned long m = millis();
  if ((m-last_tick)>ticker_speed) {
    last_tick = m;
    refreshBuffer();
  }
  printBuffer();
}

void printBuffer () {
  int i;
  unsigned long m = millis();
  drawColumn(buffer_column,buffer[buffer_column]);
  if (m-last_refresh>refresh_rate) {
    last_refresh = m;
    buffer_column = (buffer_column + 1 < cols_per_matrix) ? buffer_column + 1 : 0;
    clearMatrix();
  }
}

void drawColumn (byte col, byte values[]) {
  // primero prendemos toda la columna
  digitalWrite(cols[col],HIGH);
  // luego apagamos las filas que toca
  int i;
  for (i=0;i<buffer_rows;i++) {
    if (values[i]==0) digitalWrite(rows[i],HIGH);
  }
}

/*****
CORNER LEDs
******/

void initLEDs () {
  pinMode(a_led_pin,OUTPUT);
  pinMode(b_led_pin,OUTPUT);
  pinMode(c_led_pin,OUTPUT);
  //pinMode(d_led_pin,OUTPUT);
  analogWrite(a_led_pin,0);
  analogWrite(b_led_pin,0);
  analogWrite(c_led_pin,0);
  //digitalWrite(d_led_pin,LOW);
}

void clearLEDs () {
  analogWrite(a_led_pin,0);
  analogWrite(b_led_pin,0);
  analogWrite(c_led_pin,0);
}

void startRead () {
  is_reading = true;
  last_read = millis();
  doRead();
}

void doRead () {
  if (is_reading && (millis()-last_read < read_length)) {
    clearLEDs();
    if (current_led==1) {
      analogWrite(a_led_pin,1023);
    } else if (current_led==2) {
      analogWrite(b_led_pin,1023);
    } else if (current_led==3) {
      analogWrite(c_led_pin,1023);
    }
  }
 if (millis()-last_read >= read_length) {
    if (current_led==1) {
      current_led = 2;
    } else if (current_led==2) {
      current_led = 3;
    } else if (current_led==3) {
      current_led = 1;
    }
    last_read = millis();
  }
}

void startShining () {
  is_shining = true;
  doShine();
}

void doShine () {
  if (is_shining) {
    randomShine();
  }
}

void randomShine () {
  int coin;
  coin = round(random(0,4));
  analogWrite(a_led_pin,map(coin,0,4,0,1023));
  coin = round(random(0,4));
  analogWrite(b_led_pin,map(coin,0,4,0,1023));
  coin = round(random(0,4));
  analogWrite(c_led_pin,map(coin,0,4,0,1023));
}
