void refreshBuffer () {
  // prepares a 5x7 grid to be drawn
  unsigned long m = millis();
  emptyBuffer();
  if (mode==0) {
    // writing text
    if (!end_message) {
      textBuffer();
    } else {
      // messeage end
      // draw bmp
      last_bmp = m;
      mode = 1;
    }
  } else {
    // drawing pixels
    if (m-last_bmp<bmp_delay) {
      // keep drawing bmp
      bitStringBuffer();
    } else {
      // times up turn to text mode
      resetText();
      mode = 0;
    }
  }
}

void textBuffer () {
  char l;
  byte w;
  // datos caracter actual
  l = my_message[current];
  w = charWidth(l);
  // chequeamos cuantos caracteres alcanzo a pintar segun el ancho que tengo
  int pixels_left = buffer_cols;
  int counter = 1;
  byte pixels_to_add;
  char temp_l;
  byte temp_w;
  pixels_to_add = w - cc;
  pixels_left -= pixels_to_add;
  if (pixels_left != buffer_cols) {
    addCharToBuffer(l,cc,pixels_to_add);
  }
  if (pixels_left>0) {
    addCharToBuffer(' ',0,1);
    pixels_left--;
  }
  // metemos el resto de chars que quepan en esos pixeles
  while (pixels_left>0) {
    // preguntar si hay un current + 1
    if ((current+counter)<ml) {
      // hay caracter pa pintar
      // le metemos un espacio si no es un espacio ya
      // el char
      temp_l = my_message[(current+counter)];
      // ancho del char
      temp_w = charWidth(temp_l);
      // miramos si los pixeles que quedan son suficientes para el char
      pixels_to_add = (pixels_left>temp_w) ? temp_w : pixels_left;
      addCharToBuffer(temp_l,0,pixels_to_add);
      pixels_left -= pixels_to_add;
      if (pixels_left>0) {
        addCharToBuffer(' ',0,1);
        pixels_left--;
      }
      counter++;
    } else {
      pixels_left = 0;
    }
  }
  if (cc<w) {
    // todavia queda pixel del char a pintar
    cc++;
  } else {
    cc = 0;
    if ((current+1)<ml) {
      current++;
    } else {
      end_message = true;
      current = 0;
    }
  }
}

void bitStringBuffer () {
  // paint bmp
  switch (state) {
    case 0:
      addPixelsToBuffer(letterSPACE,0,5);
      break;
    case 1:
      addPixelsToBuffer(iconQUEST,0,5);
      break;
    case 2:
      addPixelsToBuffer(iconHEART,0,5);
      break;
    case 3:
      addPixelsToBuffer(iconEXCLAM,0,5);
      break;
    case 4:
      addPixelsToBuffer(iconHEART,0,5);
      break;
    case 5:
      addPixelsToBuffer(iconPHOTO,0,5);
      break;
    case 6:
      addPixelsToBuffer(iconVIDEO,0,5);
      break;
    case 7:
      addPixelsToBuffer(iconHEART,0,5);
      break;
  }
}

void addPixelsToBuffer (byte l[7][5], byte start, byte w) {
  int i, j;
  for (i=0;i<buffer_rows;i++) {
    for (j=0;j<w;j++) {
      buffer[bc+j][i] = l[i][start+j];
    }
  }
  bc+=w;
}

void emptyBuffer () {
  int i, j;
  for (i=0;i<buffer_cols;i++) {
    for (j=0;j<buffer_rows;j++) {
      buffer[i][j] = 0;
    }
  }
  bc=0;
}

void addCharToBuffer (char l, byte start, byte w) {
  if (l=='a') {
    addPixelsToBuffer (lettera, start, w);
  } else if (l=='A') {
    addPixelsToBuffer (letterA, start, w);
  } else if (l=='b') {
    addPixelsToBuffer (letterb, start, w);
  } else if (l=='c') {
    addPixelsToBuffer (letterc, start, w);
  } else if (l=='C') {
    addPixelsToBuffer (letterC, start, w);
  } else if (l=='d') {
    addPixelsToBuffer (letterd, start, w);
  } else if (l=='e') {
    addPixelsToBuffer (lettere, start, w);
  } else if (l=='E') {
    addPixelsToBuffer (letterE, start, w);
  } else if (l=='f') {
    addPixelsToBuffer (letterf, start, w);
  } else if (l=='g') {
    addPixelsToBuffer (letterg, start, w);
  } else if (l=='h') {
    addPixelsToBuffer (letterh, start, w);
  } else if (l=='i') {
    addPixelsToBuffer (letteri, start, w);
  } else if (l=='I') {
    addPixelsToBuffer (letterI, start, w);
  } else if (l=='j') {
    addPixelsToBuffer (letterj, start, w);
  } else if (l=='k') {
    addPixelsToBuffer (letterk, start, w);
  } else if (l=='l') {
    addPixelsToBuffer (letterl, start, w);
  } else if (l=='m') {
    addPixelsToBuffer (letterm, start, w);
  } else if (l=='M') {
    addPixelsToBuffer (letterM, start, w);
  } else if (l=='n') {
    addPixelsToBuffer (lettern, start, w);
  } else if (l=='N') {
    addPixelsToBuffer (letterN, start, w);
  } else if (l=='o') {
    addPixelsToBuffer (lettero, start, w);
  } else if (l=='O') {
    addPixelsToBuffer (letterO, start, w);
  } else if (l=='P') {
    addPixelsToBuffer (letteroslash, start, w);
  } else if (l=='Q') {
    addPixelsToBuffer (letterodieresis, start, w);
  } else if (l=='p') {
    addPixelsToBuffer (letterp, start, w);
  } else if (l=='q') {
    addPixelsToBuffer (letterq, start, w);
  } else if (l=='r') {
    addPixelsToBuffer (letterr, start, w);
  } else if (l=='s') {
    addPixelsToBuffer (letters, start, w);
  } else if (l=='t') {
    addPixelsToBuffer (lettert, start, w);
  } else if (l=='T') {
    addPixelsToBuffer (letterthorn, start, w);
  } else if (l=='u') {
    addPixelsToBuffer (letteru, start, w);
  } else if (l=='U') {
    addPixelsToBuffer (letterU, start, w);
  } else if (l=='V') {
    addPixelsToBuffer (letterudieresis, start, w);
  } else if (l=='v') {
    addPixelsToBuffer (letterv, start, w);
  } else if (l=='w') {
    addPixelsToBuffer (letterw, start, w);
  } else if (l=='x') {
    addPixelsToBuffer (letterx, start, w);
  } else if (l=='y') {
    addPixelsToBuffer (lettery, start, w);
  } else if (l=='Y') {
    addPixelsToBuffer (letterydieresis, start, w);
  } else if (l=='z') {
    addPixelsToBuffer (letterz, start, w);
  } else if (l=='_') {
    addPixelsToBuffer (letter_, start, w);
  } else if (l=='1') {
    addPixelsToBuffer (letter1, start, w);
  } else if (l=='2') {
    addPixelsToBuffer (letter2, start, w);
  } else if (l=='3') {
    addPixelsToBuffer (letter3, start, w);
  } else if (l=='4') {
    addPixelsToBuffer (letter4, start, w);
  } else if (l=='5') {
    addPixelsToBuffer (letter5, start, w);
  } else if (l=='6') {
    addPixelsToBuffer (letter6, start, w);
  } else if (l=='7') {
    addPixelsToBuffer (letter7, start, w);
  } else if (l=='8') {
    addPixelsToBuffer (letter8, start, w);
  } else if (l=='9') {
    addPixelsToBuffer (letter9, start, w);
  } else if (l=='0') {
    addPixelsToBuffer (letter0, start, w);
  } else if (l=='-') {
    addPixelsToBuffer (letterMINUS, start, w);
  } else if (l=='+') {
    addPixelsToBuffer (letterPLUS, start, w);
  } else if (l=='/') {
    addPixelsToBuffer (letterSLASH, start, w);
  } else if (l=='*') {
    addPixelsToBuffer (letterTIMES, start, w);
  } else if (l=='=') {
    addPixelsToBuffer (letterEQUAL, start, w);
  } else if (l==':') {
    addPixelsToBuffer (letterCOLON, start, w);
  } else if (l=='.') {
    addPixelsToBuffer (letterPERIOD, start, w);
  } else if (l==',') {
    addPixelsToBuffer (letterCOMMA, start, w);
  } else if (l==';') {
    addPixelsToBuffer (letterSEMICOLON, start, w);
  } else if (l=='|') {
    addPixelsToBuffer (letterPIPE, start, w);
  } else if (l=='!') {
    addPixelsToBuffer (letterEXCLAM, start, w);
  } else if (l=='?') {
    addPixelsToBuffer (letterQUEST, start, w);
  } else if (l=='(') {
    addPixelsToBuffer (letterLPAREN, start, w);
  } else if (l==')') {
    addPixelsToBuffer (letterRPAREN, start, w);
  } else if (l==' ') {
    addPixelsToBuffer (letterSPACE, start, w);
  }
}

byte charWidth (char l) {
  if (l=='a') {
    return 4;
  } else if (l=='A') {
    return 5;
  } else if (l=='b') {
    return 4;
  } else if (l=='c') {
    return 4;
  } else if (l=='C') {
    return 4;
  } else if (l=='d') {
    return 4;
  } else if (l=='e') {
    return 4;
  } else if (l=='E') {
    return 5;
  } else if (l=='f') {
    return 4;
  } else if (l=='g') {
    return 4;
  } else if (l=='h') {
    return 3;
  } else if (l=='i') {
    return 3;
  } else if (l=='I') {
    return 3;
  } else if (l=='j') {
    return 2;
  } else if (l=='k') {
    return 4;
  } else if (l=='l') {
    return 3;
  } else if (l=='m') {
    return 5;
  } else if (l=='M') {
    return 5;
  } else if (l=='n') {
    return 4;
  } else if (l=='N') {
    return 4;
  } else if (l=='o') {
    return 4;
  } else if (l=='O') {
    return 5;
  } else if (l=='P') {
    return 4;
  } else if (l=='Q') {
    return 4;
  } else if (l=='p') {
    return 4;
  } else if (l=='q') {
    return 4;
  } else if (l=='r') {
    return 3;
  } else if (l=='s') {
    return 3;
  } else if (l=='t') {
    return 4;
  } else if (l=='T') {
    return 3;
  } else if (l=='u') {
    return 5;
  } else if (l=='U') {
    return 5;
  } else if (l=='V') {
    return 5;
  } else if (l=='v') {
    return 5;
  } else if (l=='w') {
    return 5;
  } else if (l=='x') {
    return 4;
  } else if (l=='y') {
    return 4;
  } else if (l=='Y') {
    return 4;
  } else if (l=='z') {
    return 4;
  } else if (l=='_') {
    return 4;
  } else if (l=='1') {
    return 3;
  } else if (l=='2') {
    return 4;
  } else if (l=='3') {
    return 4;
  } else if (l=='4') {
    return 5;
  } else if (l=='5') {
    return 4;
  } else if (l=='6') {
    return 4;
  } else if (l=='7') {
    return 4;
  } else if (l=='8') {
    return 4;
  } else if (l=='9') {
    return 4;
  } else if (l=='0') {
    return 4;
  } else if (l=='-') {
    return 3;
  } else if (l=='+') {
    return 3;
  } else if (l=='/') {
    return 3;
  } else if (l=='*') {
    return 3;
  } else if (l=='=') {
    return 3;
  } else if (l==':') {
    return 1;
  } else if (l=='.') {
    return 1;
  } else if (l==',') {
    return 2;
  } else if (l==';') {
    return 2;
  } else if (l=='|') {
    return 1;
  } else if (l=='!') {
    return 1;
  } else if (l=='?') {
    return 4;
  } else if (l=='(') {
    return 2;
  } else if (l==')') {
    return 2;
  } else if (l==' ') {
    return 2;
  } else {
    return 0;
  }
}
