void behave () {
  checkI2C();
  BTcheck();
  if (digitalRead(capacitive_led_pin) && state!=7) {
    // was not being touched and now is
    state_changed = true;
    tmp_state = 7;
  } else if ((!digitalRead(capacitive_led_pin) && state==7) && tmp_state==0) {
    // not touched and no BT
    state_changed = true;
    tmp_state = 0;
  } else if (tmp_state!=0) {
    // BT data!
    state_changed = true;
  }
  
  if (state_changed) {
    Serial.println("clearing");
    Serial.print("new state: ");
    Serial.print(tmp_state);
    Serial.print(" msg: ");
    Serial.println(username);
    // there is a new state and we are done drawing
    username.toCharArray(my_message,username.length());
    ml = username.length();
    state = tmp_state;
    falseFlags();
    clearAll();
    switch (state) {
      case 0:
        beNothing();
        break;
      case 1:
        beTweet();
        break;
      case 2:
        beFollow();
        break;
      case 3:
        beMention();
        break;
      case 4:
        beMessage();
        break;
      case 5:
        bePhoto();
        break;
      case 6:
        beVideo();
        break;
      case 7:
        doSleep();
        break;
    }
  }
  drawMatrix();
  applyActions();
}

/**
  high-level behaviors
  0 = basic
  1 = tweet
  2 = follow
  3 = mention
  4 = message
  5 = photo
  6 = video
  7 = sleep
/**/

// 0
void beNothing () {
  String tmp = " please hug me ";
  tmp.toCharArray(my_message,tmp.length());
  ml = tmp.length();
}

// 1
void beTweet () {
  startBeep(500);
}

// 2
void beFollow () {
  startVibrate(1000);
}

// 3
void beMention () {
  startShining();
}

// 4
void beMessage () {
  startRead();
}

// 5
void bePhoto () {
  startVibrate(1000);
  startBeep(500);
}

// 6
void beVideo () {
  startVibrate(2000);
  startBeep(2000);
}

// 7
void doSleep () {
  if (!is_sleeping) {
    is_sleeping = true;
    start_sleeping = millis();
    String tmp = " zzzzzzzz ";
    tmp.toCharArray(my_message,tmp.length());
    ml = tmp.length();
  }
  int value;
  if (is_sleeping) {
    if (sleep_direction==1) {
      value = round((millis()-start_sleeping)*1023/sleep_length);
      if (value>1023) {
        start_sleeping = millis();
        value = 1023;
        sleep_direction = 2;
      }
    } else if (sleep_direction==2) {
      value = 1023 - round((millis()-start_sleeping)*1023/sleep_length);
      if (value<=0) {
        start_sleeping = millis();
        value = 0;
        sleep_direction = 1;
      }
    }
    analogWrite(a_led_pin,value);
    analogWrite(b_led_pin,value);
    analogWrite(c_led_pin,value);
  }
}

/**
low level behaviors
/**/

void applyActions () {
  doBeep();
  doVibrate();
  doShine();
  doRead();
}

void clearAll () {
  falseFlags();
  clearLEDs();
  resetScreen();
  disableVibrator();
  disableBuzzer();
}

void falseFlags() {
  state_changed = false;
  is_sleeping = false;
  is_vibrating = false;
  is_beeping = false;
  is_reading = false;
  is_shining = false;
}
