void setup () {
  Serial.begin(9600);
  Serial1.begin(9600);
  // status led
  pinMode(status_led_pin, OUTPUT);
  setStatus("off");
  // crear la matriz con los pines
  initI2C();
  initMatrix();
  initLEDs();
  initBuzzer();
  refreshBuffer();
}

void loop () {
  behave();
}

void resetScreen () {
  // clean text part
  resetText();
  // start
  refreshBuffer();
  // change to bitmap mode
  mode = 1;
  last_bmp = millis();
}

void resetText () {
  current = 0;
  bc = 0;
  cc = 0;
  end_message = false;
}

void parseMessage () {
  String txt;
  // get the number part
  txt = serial_message.substring(0,1);
  char txtnum = txt[0];
  if (txtnum=='1') {
    tmp_state = 1;
  } else if (txtnum=='2') {
    tmp_state = 2;
  } else if (txtnum=='3') {
    tmp_state = 3;
  } else if (txtnum=='4') {
    tmp_state = 4;
  } else if (txtnum=='5') {
    tmp_state = 5;
  } else if (txtnum=='6') {
    tmp_state = 6;
  }
  // get the username
  txt = serial_message.substring(2,bytes_to_read-1);
  username = txt.replace('/',' ').trim();
  // add some space before and after
  username = "  " + username + "  ";
  serial_message = "";
  Serial.print("message parsed: ");
  Serial.print(tmp_state);
  Serial.print(" user: ");
  Serial.println(username);
}

void BTcheck () {
  // serial check
  if (Serial1.available() > 0){
      Serial.print("there is data: ");
      serial_message = "";
      setStatus("on");
      bytes_read = 0;
      while (bytes_read < bytes_to_read) {
        // second check
        if (Serial1.available() > 0) {
          // read data from serial port
          serial_data = Serial1.read();
          /**/
          if (serial_data == '_') {
            // if header or stop bytes before the limit digit reading
            break;
          }
          /**/
          serial_message += serial_data;
          bytes_read++;
        }
      }
      if (bytes_read != bytes_to_read-1) {
        // not enough bytes read but data in serial
        // kill it and go to base state
        Serial.flush();
        serial_message = "";
        username = "";
        tmp_state = 0;
        setStatus("off");
        bytes_read = 0;
      } else {
        parseMessage();
      }
  } else {
    Serial1.flush();
    setStatus("off");
    serial_message = "";
    username = "";
    tmp_state = 0;
    bytes_read = 0;
  }
}

void setStatus (String status) {
  if (status=="on") {
    digitalWrite(status_led_pin,HIGH);
  } else {
    digitalWrite(status_led_pin,LOW);
  }
}


